using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.DataEngine;
using CMS.Controls;
using CMS.PortalEngine;
using CMS.SettingsProvider;
using CMS.ExtendedControls;

public partial class CMSWebParts_CustomTables_CustomTableDataGrid : CMSAbstractWebPart
{
    #region "Document properties"

    /// <summary>
    /// Gets or sets the cache item name
    /// </summary>
    public override string CacheItemName
    {
        get
        {
            return base.CacheItemName;
        }
        set
        {
            base.CacheItemName = value;
            this.gridItems.CacheItemName = value;
        }
    }


    /// <summary>
    /// Cache dependencies, each cache dependency on a new line
    /// </summary>
    public override string CacheDependencies
    {
        get
        {
            return ValidationHelper.GetString(base.CacheDependencies, this.gridItems.CacheDependencies);
        }
        set
        {
            base.CacheDependencies = value;
            this.gridItems.CacheDependencies = value;
        }
    }


    /// <summary>
    /// Gets or sets the cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return base.CacheMinutes;
        }
        set
        {
            base.CacheMinutes = value;
            this.gridItems.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Gets or sets the order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.gridItems.OrderBy), this.gridItems.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.gridItems.OrderBy = value;
        }
    }


    /// <summary>
    /// Gets or sets where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.gridItems.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.gridItems.WhereCondition = value;
        }
    }

    #endregion


    #region "Public properties"

    /// <summary>
    /// Gets or sets the value that indicates whether first page is sets when sort of some column is changed
    /// </summary>
    public bool SetFirstPageAfterSortChange
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SetFirstPageAfterSortChange"), this.gridItems.SetFirstPageAfterSortChange);
        }
        set
        {
            this.SetValue("SetFirstPageAfterSortChange", value);
            this.gridItems.SetFirstPageAfterSortChange = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether permissions should be checked
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.gridItems.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.gridItems.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Gets or sets the text which is displayed for zero rows result
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.gridItems.ZeroRowsText), this.gridItems.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.gridItems.ZeroRowsText = value;
        }
    }


    /// <summary>
    /// Gets or sets the number which indicates how many documents should be displayed
    /// </summary>
    public int SelectTopN
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("SelectTopN"), this.gridItems.SelectTopN);
        }
        set
        {
            this.SetValue("SelectTopN", value);
            this.gridItems.SelectTopN = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether sorting is ascending at default
    /// </summary>
    public bool SortAscending
    {
        get
        {
        	 return (ValidationHelper.GetBoolean(this.GetValue("SortAscending"), this.gridItems.SortAscending)); 
        }
        set
        {
            this.SetValue("SortAscending", value);
            this.gridItems.SortAscending = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether sorting is allowed
    /// </summary>
    public bool AllowSorting
    {
        get
        {
        	 return ValidationHelper.GetBoolean(this.GetValue("AllowSorting"), this.gridItems.AllowSorting); 
        }
        set
        {
            this.SetValue("AllowSorting", value);
            this.gridItems.AllowSorting = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that inidcates whether sorting process is proceeded in the code
    /// </summary>
    public bool ProcessSorting
    {
        get
        {
        	 return ValidationHelper.GetBoolean(this.GetValue("ProcessSorting"), this.gridItems.ProcessSorting); 
        }
        set
        {
            this.SetValue("ProcessSorting", value);
            this.gridItems.ProcessSorting = value;
        }
    }


    /// <summary>
    /// Gets or sets the default sort field
    /// </summary>
    public string SortField
    {
        get
        {
        	 return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SortField"), this.gridItems.SortField), this.gridItems.SortField); 
        }
        set
        {
            this.SetValue("SortField", value);
            this.gridItems.SortField = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether paging will be allowed
    /// </summary>
    public bool AllowPaging
    {
        get
        {
        	 return ValidationHelper.GetBoolean(this.GetValue("AllowPaging"), this.gridItems.AllowPaging); 
        }
        set
        {
            this.SetValue("AllowPaging", value);
            this.gridItems.AllowPaging = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether custom paging is enabled
    /// </summary>
    public bool AllowCustomPaging
    {
        get
        {
        	 return ValidationHelper.GetBoolean(this.GetValue("AllowCustomPaging"), this.gridItems.AllowCustomPaging); 
        }
        set
        {
            this.SetValue("AllowCustomPaging", value);
            this.gridItems.AllowCustomPaging = value;
        }
    }


    /// <summary>
    /// Gets or sets the size of the page if the paging is allowed
    /// </summary>
    public int PageSize
    {
        get
        {
        	 return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.gridItems.PageSize); 
        }
        set
        {
            this.SetValue("PageSize", value);
            this.gridItems.PageSize = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether databind will be proceeded automatically
    /// </summary>
    public bool DataBindByDefault
    {
        get
        {
        	 return ValidationHelper.GetBoolean(this.GetValue("DataBindByDefault"), this.gridItems.DataBindByDefault); 
        }
        set
        {
            this.SetValue("DataBindByDefault", value);
            this.gridItems.DataBindByDefault = value;
        }
    }


    /// <summary>
    /// Gets or sets the paging mode
    /// </summary>
    public PagerMode PagingMode
    {
        get
        {
        	 return this.gridItems.GetPagerMode(ValidationHelper.GetString(this.GetValue("Mode"), "")); 
        }
        set
        {
            this.SetValue("Mode", value);
        }
    }


    /// <summary>
    /// Gets or sets the value that inidcates whether header will be displayed
    /// </summary>
    public bool ShowHeader
    {
        get
        {
        	 return ValidationHelper.GetBoolean(this.GetValue("ShowHeader"), this.gridItems.ShowHeader); 
        }
        set
        {
            this.SetValue("ShowHeader", value);
            this.gridItems.ShowHeader = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether footer will be displayed
    /// </summary>
    public bool ShowFooter
    {
        get
        {
        	 return ValidationHelper.GetBoolean(this.GetValue("ShowFooter"), this.gridItems.ShowFooter); 
        }
        set
        {
            this.SetValue("ShowFooter", value);
            this.gridItems.ShowFooter = value;
        }
    }


    /// <summary>
    /// Gets or sets the tool tip text
    /// </summary>
    public string ToolTip
    {
        get
        {
        	 return DataHelper.GetNotEmpty(this.GetValue("ToolTip"), this.gridItems.ToolTip); 
        }
        set
        {
            this.SetValue("ToolTip", value);
            this.gridItems.ToolTip = value;
        }
    }


    /// <summary>
    /// Gets or sets the value that indicates whether columns should be generated automatically
    /// </summary>
    public bool AutoGenerateColumns
    {
        get
        {
        	 return ValidationHelper.GetBoolean(this.GetValue("AutoGenerateColumns"), this.gridItems.AutoGenerateColumns); 
        }
        set
        {
            this.SetValue("AutoGenerateColumns", value);
            this.gridItems.AutoGenerateColumns = value;
        }
    }


    /// <summary>
    /// Gets or sets the custom table
    /// </summary>
    public string CustomTable
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("CustomTable"), "");
        }
        set
        {
            this.SetValue("CustomTable", value);
        }
    }


    /// <summary>
    /// Gets or sets the value that represent column selector settings
    /// </summary>
    public string ColumnsSelector
    {
        get
        {
        	 return DataHelper.GetNotEmpty(this.GetValue("ColumnSelector"), ""); 
        }
        set
        {
            this.SetValue("ColumnSelector", value);
        }
    }


    /// <summary>
    /// Filter name.
    /// </summary>
    public string FilterName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("FilterName"), gridItems.FilterName);
        }
        set
        {
            this.SetValue("FilterName", value);
            this.gridItems.FilterName = value;
        }
    }


    /// <summary>
    /// Detail page path.
    /// </summary>
    public string DetailPagePath
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("DetailPagePath"), null);
        }
        set
        {
            this.SetValue("DetailPagePath", value);
        }
    }

    #endregion


    protected string[] mColumnList;
    protected string[] mGlobalNameID = null;
    protected string[] mDataType = null;

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if (this.StopProcessing)
        {
            this.gridItems.StopProcessing = true;
        }
        else
        {
            this.gridItems.ControlContext = this.ControlContext;

            this.gridItems.CacheItemName = this.CacheItemName;
            this.gridItems.CacheDependencies = this.CacheDependencies;
            this.gridItems.CacheMinutes = this.CacheMinutes;
            this.gridItems.OrderBy = this.OrderBy;
            this.gridItems.WhereCondition = this.WhereCondition;
            this.gridItems.FilterName = this.FilterName;

            this.gridItems.SelectTopN = this.SelectTopN;
            this.gridItems.HideControlForZeroRows = this.HideControlForZeroRows;
            this.gridItems.ZeroRowsText = this.ZeroRowsText;

            this.gridItems.EnableViewState = true;

            this.gridItems.AllowSorting = this.AllowSorting;
            this.gridItems.ProcessSorting = this.ProcessSorting;
            this.gridItems.SortAscending = this.SortAscending;
            this.gridItems.SortField = this.SortField;

            this.gridItems.AllowPaging = this.AllowPaging;
            this.gridItems.PageSize = this.PageSize;
            this.gridItems.AllowCustomPaging = this.AllowCustomPaging;
            this.gridItems.PagerStyle.Mode = this.PagingMode;
            this.gridItems.ShowHeader = this.ShowHeader;
            this.gridItems.ShowFooter = this.ShowFooter;

            this.gridItems.ToolTip = this.ToolTip;

            this.gridItems.DataBindByDefault = this.DataBindByDefault;

            this.gridItems.AutoGenerateColumns = this.AutoGenerateColumns;

            DataClassInfo dci = DataClassInfoProvider.GetDataClass(this.CustomTable);
            if (dci != null)
            {
                this.gridItems.QueryName = dci.ClassName + ".selectall";
            }

            this.gridItems.SetFirstPageAfterSortChange = this.SetFirstPageAfterSortChange;

            string mXML = this.ColumnsSelector;

            this.gridItems.DataBindByDefault = false;

            // Set SkinID properties
            if (!this.StandAlone && (this.PageCycle < PageCycleEnum.Initialized) && (ValidationHelper.GetString(this.Page.StyleSheetTheme, "") == ""))
            {
                this.gridItems.SkinID = this.SkinID;
            }

            LoadFromQuery(this.gridItems.QueryName);

            if (ColumnSelector(mXML))
            {
                this.gridItems.AutoGenerateColumns = false;
            }
        }
    }


    /// <summary>
    /// Applies given stylesheet skin
    /// </summary>
    public override void ApplyStyleSheetSkin(Page page)
    {
        this.gridItems.SkinID = this.SkinID;
        base.ApplyStyleSheetSkin(page);
    }


    /// <summary>
    /// Page load
    /// </summary>
    protected void Page_Load(object sender, EventArgs e)
    {
        this.gridItems.ReloadData(true);
    }


    /// <summary>
    /// OnPrerender override (Set visibility)
    /// </summary>
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        this.Visible = this.gridItems.Visible;

        if (DataHelper.DataSourceIsEmpty(this.gridItems.DataSource) && (this.HideControlForZeroRows))
        {
            this.Visible = false;
        }
    }


    /// <summary>
    /// Reload data
    /// </summary>
    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.gridItems.ReloadData(true);
    }


    /// <summary>
    /// Check if column is valid for classnames
    /// </summary>
    /// <param name="mColumn">Name of column</param>
    /// <returns>Return true if column is on table</returns>
    protected bool IsInTable(string mColumn)
    {
        if ((mColumn == null) || (mColumn == ""))
        {
            return false;
        }

        for (int i = mColumnList.GetLowerBound(0); i <= mColumnList.GetUpperBound(0); i++)
        {
            if (mColumnList[i] == mColumn)
            {
                return true;
            }
        }

        return false;
    }


    /// <summary>
    /// Load Columns names with Query
    /// </summary>
    protected void LoadFromQuery(string mQueryName)
    {
        if (DataHelper.GetNotEmpty(mQueryName, "") != "")
        {
            // Load the data
            this.gridItems.ReloadData(false);
            DataView dv = DataHelper.GetDataView(this.gridItems.DataSource);

            string[] mCl = new string[dv.Table.Columns.Count];
            string[] mDt = new string[dv.Table.Columns.Count];

            int i = 0;
            foreach (DataColumn dc in dv.Table.Columns)
            {
                mCl[i] = dc.ColumnName;
                mDt[i] = dc.DataType.ToString();
                i++;
            }
            this.mDataType = mDt;
            this.mColumnList = mCl;
        }
    }


    /// <summary>
    /// Get information from XML and add it to columns
    /// </summary>
    /// <param name="mXML">Input XML string</param>
    /// <returns>Return false if params is null or empty or when Xml haven't any node</returns>
    protected bool ColumnSelector(string mXML)
    {
        // Check valid state
        if (String.IsNullOrEmpty(mXML))
        {
            return false;
        }

        if ((mColumnList == null) || (mColumnList.Length == 0))
        {
            return false;
        }

        //Create XML document from string
        XmlDocument mXMLDocument = new XmlDocument();

        mXMLDocument.LoadXml(mXML);

        // Get column list
        XmlNodeList NodeList = mXMLDocument.DocumentElement.GetElementsByTagName("column");

        //If empty, nothing to do
        if (NodeList.Count == 0)
        {
            return false;
        }

        string mName = null;
        string mHeader = null;
        string mType = null;

        this.gridItems.ItemDataBound += new DataGridItemEventHandler(gridItems_ItemDataBound);

        this.gridItems.Columns.Clear();

        foreach (XmlNode node in NodeList)
        {
            // Get attributes values
            mName = XmlHelper.GetXmlAttributeValue(node.Attributes["name"], "");
            mHeader = XmlHelper.GetXmlAttributeValue(node.Attributes["header"], "");
            mType = XmlHelper.GetXmlAttributeValue(node.Attributes["type"], "");

            if (DataHelper.GetNotEmpty(mName, "") != "")
            {
                // Check if column is in the table
                if (IsInTable(mName))
                {
                    // Grid value as link
                    if (mType == "link")
                    {
                        if (mGlobalNameID == null)
                        {
                            mGlobalNameID = new string[0];
                        }

                        string[] mHelpGlobal = new string[mGlobalNameID.Length + 1];

                        mHelpGlobal[mGlobalNameID.Length] = mName;

                        for (int i = 0; i < mGlobalNameID.Length; i++)
                        {
                            mHelpGlobal[i] = mGlobalNameID[i];
                        }

                        mGlobalNameID = mHelpGlobal;


                        TemplateColumn col = new TemplateColumn();
                        col.ItemTemplate = new LinkItemTemplate(mName);

                        // First try header then name
                        col.HeaderText = DataHelper.GetNotEmpty(mHeader, mName);

                        if (this.gridItems.AllowSorting)
                        {
                            col.SortExpression = mName;
                        }

                        // Add column to the grid
                        this.gridItems.Columns.Add(col);
                    }
                    // Not link
                    else
                    {
                        BoundColumn col = new BoundColumn();

                        col.DataField = mName;

                        // First try header then name
                        col.HeaderText = DataHelper.GetNotEmpty(mHeader, mName);

                        if (this.gridItems.AllowSorting)
                        {
                            col.SortExpression = mName;
                        }

                        this.gridItems.Columns.Add(col);
                    }
                }
            }
        }

        return true;
    }


    /// <summary>
    /// Item data bound handler
    /// </summary>
    void gridItems_ItemDataBound(object sender, DataGridItemEventArgs e)
    {
        if (mGlobalNameID != null)
        {
            for (int i = mGlobalNameID.GetLowerBound(0); i <= mGlobalNameID.GetUpperBound(0); i++)
            {
                if (mGlobalNameID[i] != null && mGlobalNameID[i] != "")
                {
                    Control ctrl = e.Item.FindControl(mGlobalNameID[i]);
                    if (ctrl != null)
                    {
                        ((HyperLink)ctrl).Text = ((DataRowView)e.Item.DataItem)[mGlobalNameID[i]].ToString();
                        int itemId = ValidationHelper.GetInteger(DataHelper.GetDataRowViewValue((DataRowView)e.Item.DataItem, "ItemID"), 0);
                        string detailUrl = UrlHelper.CurrentURL;
                        
                        // Use current page by default
                        if (!string.IsNullOrEmpty(DetailPagePath))
                        {
                            detailUrl = CMSContext.GetUrl(DetailPagePath);
                        }

                        // Add querystring parametr
                        detailUrl = UrlHelper.AddParameterToUrl(detailUrl, "id", itemId.ToString());

                        ((HyperLink)ctrl).NavigateUrl = detailUrl;
                    }
                }
            }
        }
    }


    /// <summary>
    /// Clears cache.
    /// </summary>
    public override void ClearCache()
    {
        this.gridItems.ClearCache();
    }
}


