/****** Object:  StoredProcedure [Proc_CMS_User_IsAuthorizedPerNode]    Script Date: 03/17/2009 08:51:00 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [Proc_CMS_Site_RemoveDependences] 
    @SiteID int
AS
BEGIN
    -- SET NOCOUNT ON added to prevent extra result sets from
    -- interfering with SELECT statements.
    SET NOCOUNT ON;
    -- removes VersionHistory dependences from VersionAttachment
    DELETE FROM [CMS_VersionAttachment] WHERE VersionHistoryID IN (
        SELECT VersionHistoryID FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID
    );
    -- removes VersionHistory dependences from WorkflowHistory
    DELETE FROM [CMS_WorkflowHistory] WHERE VersionHistoryID IN (
        SELECT VersionHistoryID FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID
    );
    -- deletes site's VersionHistory
    DELETE FROM [CMS_VersionHistory] WHERE NodeSiteID = @SiteID;
    -- deletes site's SettingKeys
    DELETE FROM [CMS_SettingsKey] WHERE SiteID=@SiteID;
    -- deletes site's EmailTemplates
    DELETE FROM [CMS_EmailTemplate] WHERE EmailTemplateSiteID=@SiteID;
    -- deletes site's DomainAliases
    DELETE FROM [CMS_SiteDomainAlias] WHERE SiteID=@SiteID;
    -- deletes site's cultures
    DELETE FROM [CMS_SiteCulture] WHERE SiteID=@SiteID;

    -- declare temporary templates table
	DECLARE @templateTable TABLE (
		PageTemplateID int NOT NULL
	);	
	-- get the all templates to be deleted 
	INSERT INTO @templateTable SELECT PageTemplateID FROM CMS_PageTemplate WHERE (PageTemplateID IN (SELECT PageTemplateID FROM CMS_PageTemplateSite WHERE SiteID = @SiteID ) OR PageTemplateSiteID = @SiteID) GROUP BY PageTemplateID HAVING COUNT(PageTemplateID) = 1
	
	-- delete pagetemplate <-> site bindings
    DELETE FROM [CMS_PageTemplateSite] WHERE SiteID=@SiteID;
    -- delete page templates that are not used anywhere else
    DELETE FROM [CMS_PageTemplate] WHERE PageTemplateSiteID=@SiteID AND PageTemplateID IN (SELECT * FROM @templateTable);

    -- deletes site's Users
    DELETE FROM [CMS_UserSite] WHERE SiteID=@SiteID;
    -- removes Role's dependences when site's Roles are deleted
    DELETE FROM [Forums_ForumRoles ] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [CMS_UserRole] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [CMS_RolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [CMS_WorkflowStepRoles] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [Polls_PollRoles] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    DELETE FROM [CMS_FormRole] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID=@SiteID
    );
    DELETE FROM [Community_GroupRolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
	DELETE FROM [Media_LibraryRolePermission] WHERE RoleID IN (
        SELECT RoleID FROM [CMS_Role] WHERE SiteID = @SiteID
    );
    -- deletes site's Roles
    DELETE FROM [CMS_Role] WHERE SiteID=@SiteID;
    -- deletes site's Resources
    DELETE FROM [CMS_ResourceSite] WHERE SiteID=@SiteID;
    -- deletes site's Classes
    DELETE FROM [CMS_ClassSite] WHERE SiteID=@SiteID;
    -- deletes Events of the site
    DELETE FROM [CMS_EventLog] WHERE SiteID=@SiteID;
    -- deletes site's RelationshipNames
    DELETE FROM [CMS_RelationshipNameSite] WHERE SiteID=@SiteID;
    -- deletes site's WorkflowScopes
    DELETE FROM [CMS_WorkflowScope] WHERE ScopeSiteID=@SiteID;
    -- deletes site's CSSStylesheets
    DELETE FROM CMS_CssStylesheetSite WHERE SiteID=@SiteID;
    -- deletes site's InlineControls
    DELETE FROM [CMS_InlineControlSite] WHERE SiteID=@SiteID;
    -- deletes site's ScheduledTasks
    DELETE FROM [CMS_ScheduledTask] WHERE TaskSiteID=@SiteID;


    -- deletes site's WebPart containers
    DELETE FROM CMS_WebPartContainerSite WHERE SiteID=@SiteID;
    -- deletes site Polls and site's assignment to Polls
    DELETE FROM [Polls_PollRoles] WHERE PollID IN (
            SELECT PollID FROM [Polls_Poll] WHERE PollSiteID = @SiteID
        );
    DELETE FROM [Polls_PollSite] WHERE SiteID = @SiteID;
    DELETE FROM [Polls_PollAnswer] WHERE AnswerPollID IN (
            SELECT PollID FROM [Polls_Poll] WHERE PollSiteID = @SiteID
        );
    DELETE FROM [Polls_Poll] WHERE PollSiteID = @SiteID;
    
    -- removes Newsletter_Subscriber's dependences when site's Newsletter_Subscribers are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailSubscriberID IN (
        SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
    );
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE SubscriberID IN (
        SELECT SubscriberID FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID
    );
    -- deletes site's Newsletter_Subscribers
    DELETE FROM [Newsletter_Subscriber] WHERE SubscriberSiteID=@SiteID;
    -- removes Newsletter_Newsletter's dependences when site's Newsletter_Newsletters are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
        SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
            SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
        )
    );
    DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueNewsletterID IN (
        SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
    );
    DELETE FROM [Newsletter_SubscriberNewsletter] WHERE NewsletterID IN (
        SELECT NewsletterID FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID
    );
    -- deletes site's Newsletter_Newsletters
    DELETE FROM [Newsletter_Newsletter] WHERE NewsletterSiteID=@SiteID;
    -- removes Newsletter_EmailTemplate's dependences when site's Newsletter_EmailTemplates are deleted
    DELETE FROM [Newsletter_Emails] WHERE EmailNewsletterIssueID IN (
        SELECT IssueID FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
            SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
        )
    );
    DELETE FROM [Newsletter_NewsletterIssue] WHERE IssueTemplateID IN (
            SELECT TemplateID FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID
    );
    -- deletes site's Newsletter_EmailTemplates
    DELETE FROM [Newsletter_EmailTemplate] WHERE TemplateSiteID=@SiteID;
    -- removes CMS_Class's dependences when BizForms are deleted
    DELETE FROM [CMS_Query] WHERE ClassID IN (
        SELECT FormClassID FROM [CMS_Form] WHERE FormSiteID=@SiteID
    );
    -- insert ClassIDs of BizForms into the temporaty table
    DECLARE @classIdTable TABLE (
        FormClassID int
    );
    -- get the classes
    INSERT INTO @classIdTable SELECT FormClassID FROM [CMS_Form] WHERE FormSiteID=@SiteID;
    -- deletes site's BizForms' roles from CMS_Form
    DELETE FROM [CMS_FormRole] WHERE FormID IN (SELECT FormID FROM [CMS_Form] WHERE FormSiteID=@SiteID);
    -- deletes site's BizForms' alt.forms from CMS_AlternativeForm
    DELETE FROM [CMS_AlternativeForm] WHERE FormClassID IN (SELECT FormClassID FROM @classIdTable)
        OR FormCoupledClassID IN (SELECT FormClassID FROM @classIdTable);
    -- deletes site's BizForms from CMS_Form
    DELETE FROM [CMS_Form] WHERE FormSiteID=@SiteID;
    -- deletes BizForms' records in CMS_Class
    DELETE FROM [CMS_Class] WHERE ClassID IN (SELECT FormClassID FROM @classIdTable);
    
    -- FORUM
    -- Forum user favorites
    DELETE FROM [Forums_UserFavorites] WHERE SiteID = @SiteID;
    -- Forum attachment
    DELETE FROM [Forums_Attachment] WHERE AttachmentSiteID = @SiteID;
    
    UPDATE [Forums_ForumPost]  SET PostParentID=NULL WHERE PostForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID
        ));
    DELETE FROM [Forums_ForumSubscription] WHERE SubscriptionForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumPost] WHERE PostForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumRoles ] WHERE ForumId IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    DELETE FROM [Forums_ForumModerators] WHERE ForumID IN (
        SELECT ForumID FROM [Forums_Forum] WHERE ForumGroupID  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID)
    );
    
    DELETE FROM [Forums_Forum] WHERE ForumGroupId  IN (
        SELECT GroupID FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID);    
    DELETE FROM [Forums_ForumGroup] WHERE GroupSiteID = @SiteID;
    -- delete Staging dependences
    DELETE FROM [Staging_Synchronization] WHERE 
        SynchronizationTaskID IN (SELECT TaskID FROM [Staging_Task] WHERE TaskSiteID = @SiteID)
        OR
        SynchronizationServerID IN (SELECT ServerID FROM [Staging_Server] WHERE ServerSiteID = @SiteID)
    ;
    DELETE FROM [Staging_SyncLog] WHERE 
        SyncLogTaskID IN (SELECT TaskID FROM [Staging_Task] WHERE TaskSiteID = @SiteID)
        OR 
        SyncLogServerID IN (SELECT ServerID FROM [Staging_Server] WHERE ServerSiteID = @SiteID)
    ;
    DELETE FROM [Staging_Server] WHERE ServerSiteID = @SiteID;
    -- delete StagingTasks
    DELETE FROM [Staging_Task] WHERE TaskSiteID = @SiteID;
    -- ECOMMERCE
    -- delete COM_ShoppingCart dependences
    DELETE FROM [COM_ShoppingCartSKU] WHERE ShoppingCartID IN (
        SELECT ShoppingCartID FROM [COM_ShoppingCart] WHERE ShoppingCartSiteID = @SiteID
    );
    -- delete COM_ShoppingCart
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartSiteID = @SiteID;
    -- delete COM_Order dependences
    DELETE FROM [COM_OrderStatusUser] WHERE OrderID IN (
        SELECT OrderID FROM [COM_Order] WHERE OrderSiteID = @SiteID
    );
    DELETE FROM [COM_OrderItem] WHERE OrderItemOrderID IN (
        SELECT OrderID FROM [COM_Order] WHERE OrderSiteID = @SiteID
    );
    -- delete COM_Order
    DELETE FROM [COM_Order] WHERE OrderSiteID = @SiteID;
    -- delete COM_ShippingOption dependences
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    UPDATE [COM_Customer] SET CustomerPreferredShippingOptionID=NULL WHERE CustomerPreferredShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    DELETE FROM [COM_PaymentShipping] WHERE ShippingOptionID IN (
        SELECT ShippingOptionID FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID
    );
    -- delete COM_ShippingOption
    DELETE FROM [COM_ShippingOption] WHERE ShippingOptionSiteID = @SiteID;
    -- delete COM_PaymentOption dependences
    DELETE FROM [COM_ShoppingCart] WHERE ShoppingCartPaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    UPDATE [COM_Customer] SET CustomerPrefferedPaymentOptionID=NULL WHERE CustomerPrefferedPaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    DELETE FROM [COM_PaymentShipping] WHERE PaymentOptionID IN (
        SELECT PaymentOptionID FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID
    );
    -- delete COM_PaymentOption
    DELETE FROM [COM_PaymentOption] WHERE PaymentOptionSiteID = @SiteID;
    -- delete items from COM_Wishlist
    DELETE FROM [COM_Wishlist] WHERE SiteID = @SiteID;
    -- WEB ANALYTICS
    -- delete Analytics_Statistics dependences
    DELETE FROM Analytics_DayHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_HourHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_MonthHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_WeekHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    DELETE FROM Analytics_YearHits WHERE HitsStatisticsID IN (
        SELECT StatisticsID FROM Analytics_Statistics WHERE StatisticsSiteID=@SiteID);
    -- delete Analytics_Statistics
    DELETE FROM Analytics_Statistics WHERE StatisticsSiteID = @SiteID;
    -- POLLS
    DELETE FROM Polls_PollSite WHERE SiteID = @SiteID;
    -- Metafiles
    DELETE FROM CMS_MetaFile WHERE MetaFileSiteID = @SiteID;
    -- Export history
    DELETE FROM Export_History WHERE ExportSiteID = @SiteID;
    DELETE FROM Export_Task WHERE TaskSiteID = @SiteID;
    -- Notifications
    DELETE FROM Notification_Subscription WHERE SubscriptionTemplateID IN (SELECT TemplateID FROM Notification_Template WHERE TemplateSiteID = @SiteID);
    DELETE FROM Notification_TemplateText WHERE Notification_TemplateText.TemplateID IN (SELECT TemplateID FROM Notification_Template WHERE TemplateSiteID = @SiteID);
    DELETE FROM Notification_Template WHERE TemplateSiteID = @SiteID;
    DELETE FROM Notification_Subscription WHERE SubscriptionSiteID = @SiteID;
    -- Media libraries
    DELETE FROM Media_LibraryRolePermission WHERE LibraryID IN (SELECT Media_Library.LibraryID FROM Media_Library WHERE LibrarySiteID = @SiteID);
    DELETE FROM Media_File WHERE FileLibraryID IN (SELECT Media_Library.LibraryID FROM Media_Library WHERE LibrarySiteID = @SiteID);
    DELETE FROM Media_Library WHERE LibrarySiteID = @SiteID;
    -- Delete Tags
    DELETE FROM [CMS_Tag] WHERE TagGroupID  IN (
        SELECT TagGroupID FROM [CMS_TagGroup] WHERE TagGroupSiteID = @SiteID);    
    DELETE FROM [CMS_TagGroup] WHERE TagGroupSiteID = @SiteID;
    -- Groups
    DELETE FROM [Community_GroupMember] WHERE MemberGroupID IN (
        SELECT GroupID FROM [Community_Group] WHERE GroupSiteID = @SiteID
    );
    DELETE FROM [Community_Group] WHERE GroupSiteID = @SiteID;
    -- Report abuse
    DELETE FROM [CMS_AbuseReport] WHERE ReportSiteID = @SiteID;
    -- Banned IPs
    DELETE FROM [CMS_BannedIP] WHERE IPAddressSiteID = @SiteID;
    -- User sessions
    DELETE FROM [CMS_Session] WHERE SessionSiteID = @SiteID;
END
GO


ALTER PROCEDURE [Proc_CMS_User_IsAuthorizedPerNode]
@UserID int, @NodeID int, @PermissionName nvarchar(100), @GenericRoles nvarchar(200), @SiteID int
AS
BEGIN
DECLARE @SelectedUserID int;
SELECT TOP 1 @SelectedUserID = CMS_User.UserID
FROM CMS_User
INNER JOIN CMS_UserRole on CMS_UserRole.UserID = cms_user.UserID
INNER JOIN CMS_Role on CMS_Role.RoleID = CMS_UserRole.RoleID
INNER JOIN CMS_RolePermission on CMS_RolePermission.RoleID = CMS_Role.RoleID
INNER JOIN CMS_Permission on CMS_Permission.permissionid = CMS_RolePermission.PermissionID
INNER JOIN CMS_Class on CMS_Class.ClassID = CMS_Permission.ClassID
INNER JOIN CMS_Tree on CMS_Tree.NodeClassID = CMS_Class.ClassID
WHERE CMS_Tree.NodeID = @NodeID
and CMS_User.UserID = @UserID
and CMS_Permission.PermissionName = @PermissionName
-- Try to process special roles
IF (@SelectedUserID IS NULL) OR (@SelectedUserID = 0)
BEGIN
    DECLARE @SQL varchar(600)
    SET @SQL = 
    'SELECT TOP 1 CMS_Role.RoleID
    FROM CMS_Role
    INNER JOIN CMS_RolePermission on CMS_RolePermission.RoleID = CMS_Role.RoleID
    INNER JOIN CMS_Permission on CMS_Permission.permissionid = CMS_RolePermission.PermissionID
    INNER JOIN CMS_Class on CMS_Class.ClassID = CMS_Permission.ClassID
    INNER JOIN CMS_Tree on CMS_Tree.NodeClassID = CMS_Class.ClassID
    WHERE CMS_Tree.NodeID = ' + CAST(@NodeID AS nvarchar) + ' AND CMS_Permission.PermissionName =''' + @PermissionName + 
    ''' AND CMS_Role.RoleName IN (' + @GenericRoles + ') AND CMS_Role.SiteID=' + CAST(@SiteID AS nvarchar)
    EXEC(@SQL)
END
ELSE
SELECT @SelectedUserID
END
GO

-- UPDATE queries (selectspecobj, selectspecobjhits) of the Analytics statistics class
UPDATE CMS_Query SET QueryText='SELECT * FROM Analytics_Statistics, ##WHERE## WHERE StatisticsSiteID=@SiteID AND StatisticsCode=@CodeName AND StatisticsID=HitsStatisticsID AND StatisticsObjectID=@ObjectID AND HitsStartTime >= @TimeBegin AND HitsEndTime <= @TimeEnd' WHERE QueryName='selectspecobj' AND CMS_Query.ClassID IN (SELECT ClassID FROM CMS_Class WHERE ClassName='analytics.statistics');

UPDATE CMS_Query SET QueryText='SELECT SUM(HitsCount) FROM Analytics_Statistics, ##WHERE## WHERE StatisticsSiteID=@SiteID AND StatisticsCode=@CodeName AND StatisticsID=HitsStatisticsID AND StatisticsObjectID=@ObjectID AND HitsStartTime >= @TimeBegin AND HitsEndTime <= @TimeEnd' WHERE QueryName='selectspecobjhits' AND CMS_Query.ClassID IN (SELECT ClassID FROM CMS_Class WHERE ClassName='analytics.statistics');
GO

-- UPDATE web part CustomTableDataGrid
UPDATE CMS_WebPart SET WebpartProperties='<form><category name="Content" /><field column="CustomTable" fieldcaption="Custom table" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" fielddescription="Custom table which should be used." isPK="false" system="false" columnsize="50" publicfield="false" spellcheck="true" guid="33922b3e-4403-4df0-bf7a-cd4e028411d7"><settings><controlname>customtableselector</controlname></settings></field><category name="Content filter" /><field column="OrderBy" fieldcaption="ORDER BY expression" visible="true" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="{$documentation.webpartproperties.orderby$}" isPK="false" system="false" columnsize="500" publicfield="false" spellcheck="true" guid="fdc3b630-2b9e-4076-86c5-83265bef431c" /><field column="SelectTopN" fieldcaption="Select top N documents" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" isPK="false" system="false" fielddescription="Selects only top N items. If blank, all items are selected." publicfield="false" spellcheck="true" guid="09bc848a-5e32-49a1-a27a-c2745422a71c" /><field column="WhereCondition" fieldcaption="WHERE condition" visible="true" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="{$documentation.webpartproperties.where$}" isPK="false" system="false" columnsize="500" publicfield="false" spellcheck="true" guid="9daf8bd3-e580-410e-9204-a4efb0d68bb8" /><field column="FilterName" fieldcaption="Filter name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" guid="4434ea0b-508d-4a78-b683-12e56e43292f" fielddescription="External filter name." /><category name="Design" /><field column="ColumnSelector" fieldcaption="Displayed columns" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="500" publicfield="false" spellcheck="true" fielddescription="Allows you to select and configure the displayed columns." guid="44402310-ab54-40af-8c0d-850fe4b5a6a2"><settings><controlname>selectcolumns</controlname></settings></field><field column="ShowHeader" fieldcaption="Show header" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="Indicates if header should be shown." isPK="false" system="false" publicfield="false" spellcheck="true" guid="d8d64710-a181-479f-9fe5-98119975ec0f" /><field column="ShowFooter" fieldcaption="Show footer" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="Indicates if footer should be shown." isPK="false" system="false" publicfield="false" spellcheck="true" guid="397057ed-e9d3-46f9-b7d3-021615eea594" /><field column="ToolTip" fieldcaption="Tool tip" visible="true" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="Tool tip displayed when the table is mouse-overed." isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" guid="a37e396f-d9da-4e23-9ee6-f1b7f65b023f" /><field column="SkinID" fieldcaption="Skin ID" visible="true" columntype="text" fieldtype="textbox" allowempty="true" isPK="false" system="false" columnsize="200" fielddescription="Skin ID." publicfield="false" spellcheck="true" guid="5bf97247-d08d-460a-8b93-a290f86cf13c" /><field column="DetailPagePath" fieldcaption="Detail page path" visible="true" columntype="text" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" columnsize="450" publicfield="false" spellcheck="true" guid="31da16a0-f644-46b3-ac3f-84de4c0de2c0" visibility="none" fielddescription="Path of the detail page for selectable columns."><settings><controlname>selectsinglepath</controlname></settings></field><category name="Paging" /><field column="AllowPaging" fieldcaption="Enable paging" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="{$documentation.webpartproperties.enablepaging$}" isPK="false" system="false" publicfield="false" spellcheck="true" guid="bd5b9855-c69b-409d-9840-6ec6eeedc442" /><field column="PageSize" fieldcaption="Page size" visible="true" defaultvalue="10" columntype="integer" fieldtype="textbox" allowempty="true" fielddescription="{$documentation.webpartproperties.pagesize$}" isPK="false" system="false" publicfield="false" spellcheck="true" guid="4002dc09-5bac-4b80-a40e-3f9d7a199d76" /><field column="Mode" fieldcaption="Pager style" visible="true" columntype="text" fieldtype="dropdownlist" allowempty="true" isPK="false" system="false" columnsize="50" fielddescription="You can choose between Previous/Next buttons and page numbers." publicfield="false" spellcheck="true" guid="aa0da73e-819b-4cd3-9fa0-8c00c7859368"><settings><options><item value="nextprev" text="Previous-Next buttons" /><item value="numericpages" text="Page numbers" /></options></settings></field><category name="Sorting" /><field column="AllowSorting" fieldcaption="Enable sorting" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="Indicates if sorting should be used." isPK="false" system="false" publicfield="false" spellcheck="true" guid="352926c4-17ab-4d0c-ac89-d08dbb4e42a7" /><field column="SortField" fieldcaption="Default sort field" visible="true" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="Name of the field that will be used for sorting by default." isPK="false" system="false" columnsize="100" publicfield="false" spellcheck="true" guid="bbf3a8c1-293b-41f1-bce8-0c8508ee46d9" /><field column="SortAscending" fieldcaption="Sort ascending" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="Indicates if the default sorting should be ascending." isPK="false" system="false" publicfield="false" spellcheck="true" guid="d72928c6-7e3e-40a1-8336-47d43a628fec" /><field column="SetFirstPageAfterSortChange" fieldcaption="Set first page after chage sorting" visible="true" defaultvalue="true" columntype="boolean" fieldtype="checkbox" allowempty="false" isPK="false" system="false" publicfield="false" spellcheck="true" fielddescription="Indicates if after sorting change should be displayed first page or current page." guid="23b80aad-1e38-48ce-a214-da3a99f810af" /><category name="System settings" /><field column="CacheItemName" fieldcaption="Cache item name" visible="true" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="{$documentation.webpartproperties.cacheitemname$}" isPK="false" system="false" columnsize="200" publicfield="false" spellcheck="true" guid="0aaf2d0e-3069-4aa7-8ad8-fd27415a2805" /><field column="CacheMinutes" fieldcaption="Cache minutes" visible="true" columntype="integer" fieldtype="textbox" allowempty="true" fielddescription="{$documentation.webpartproperties.cacheminutes$}" isPK="false" system="false" publicfield="false" spellcheck="true" guid="40e07ee3-b893-448c-bc97-62de2e4c07fa" /><field column="CacheDependencies" fieldcaption="Cache dependencies" visible="true" columntype="longtext" fieldtype="usercontrol" allowempty="true" isPK="false" system="false" fielddescription="{$documentation.webpartproperties.cachedependencies$}" publicfield="false" spellcheck="true" guid="e538e91e-dbdd-4d10-aec8-51acfc3760d3" visibility="none"><settings><controlname>cachedependencies</controlname></settings></field><category name="No data behavior" /><field column="HideControlForZeroRows" fieldcaption="Hide if no record found" visible="true" defaultvalue="false" columntype="boolean" fieldtype="checkbox" allowempty="true" fielddescription="{$documentation.webpartproperties.hidenofound$}" isPK="false" system="false" publicfield="false" spellcheck="true" guid="abd393a8-9ce8-45eb-a385-ffc43f82446f" /><field column="ZeroRowsText" fieldcaption="No record found text" visible="true" defaultvalue="No data found" columntype="text" fieldtype="textbox" allowempty="true" fielddescription="{$documentation.webpartproperties.norecordtext$}" isPK="false" system="false" columnsize="50" publicfield="false" spellcheck="true" guid="84fa526e-30d4-420b-9f5b-788889d999d1" /></form>' WHERE WebPartName='CustomTableDatagrid'

